#![allow(non_camel_case_types, non_snake_case)]

#[deprecated(note = "Unverified type")]
pub type INT = i32;
#[deprecated(note = "Unverified type")]
pub type GrScreenResolution_t = INT;
#[deprecated(note = "Unverified type")]
pub type GrScreenRefresh_t = INT;

use std::os::raw::c_void;

use crate::types::{
    base::FxU32,
    extended::{GrAspectRatio_t, GrLOD_t, GrLfbWriteMode_t, GrOriginLocation_t, GrTextureFormat_t},
};

pub struct GrLfbInfo_t {
    pub size: INT,
    pub lfbPtr: *mut c_void,
    pub strideInBytes: FxU32,
    pub writeMode: GrLfbWriteMode_t,
    pub origin: GrOriginLocation_t,
}

pub struct GrTexInfo {
    pub smallLodLog2: GrLOD_t,
    pub largeLodLog2: GrLOD_t,
    pub aspectRatioLog2: GrAspectRatio_t,
    pub format: GrTextureFormat_t,
    pub data: *mut c_void,
}

pub struct GrResolution {
    pub resolution: GrScreenResolution_t,
    pub refreshRate: GrScreenRefresh_t,
    pub numColorBuffers: INT,
    pub numAuxBuffers: INT,
}
